econ.indiff = function(d) with(d,
   {x = small / big
    max(0, min(1, {
        if (all(took_big))
          # We never tested indifference amounts high enough.
            mean(c(1, max(x)))
        else if (all(!took_big))
          # We never tested indifference amounts low enough.
            min(x) / 2
        else if (min(x[!took_big]) > max(x[took_big]))
          # There's some x-value that can perfectly split this dataset,
          # so just take the midpoint of the bounding x-values.
            mean(c(min(x[!took_big]), max(x[took_big])))
        else
          # Fit a logistic-regression model
           {cs = coef(glm(took_big ~ x, family = "binomial"))
            num(-cs[1]/cs[2])}}))})

`%||%` = function (a, b)  if (length(a)) a else b

econ.indiff.per.s = function(d)
   {d = ss(d, is.na(catchtype))
    d = ddply(d, .(s, test), function(slice) data.frame(
        y = econ.indiff(slice)))
    # Also calculate the stationary factor.
    d2 = ddply(d, .(s), function(slice)
       {immed = ss(slice, test == "patience")$y %||% NA
        shifted = ss(slice, test == "shifted_patience")$y %||% NA
        y = immed / shifted
        data.frame(test = "stationarity",
            y = ifelse(y < 1, y - 1, 1/-y + 1))})
    rbind(d, ss(d2, !is.na(y)))}
